#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <mpi.h>
#ifndef array_DEF
   #define array_DEF
   #include "array.h"
#endif
#ifndef sparse_values_DEF
   #define sparse_values_DEF
   #include "sparse_values.h"
#endif
#ifndef vector_DEF
   #define vector_DEF
   #include "vector.h"
#endif
#ifndef patch_DEF
   #define patch_DEF
   #include "patch.h"
#endif
#ifndef sparse_matrix_DEF
   #define sparse_matrix_DEF
   #include "sparse_matrix.h"
#endif

#ifndef exchange_DEF
   #define exchange_DEF
   #include "exchange.h"
#endif
#ifndef timing_DEF
   #define timing_DEF
   #include "timing.h"
#endif




/***************************************************************************************************************/
int main (int argc, char *argv[])
{


int ii,itermax;
int length;
int jmin,kmin,jmax,kmax;
int loc_jmin,loc_kmin,loc_jmax,loc_kmax;
int number_of_rows;
int number_of_entries;

 vector_type pp;
 vector_type rr;
 vector_type rr_old;
 vector_type xx;
 vector_type Axx;
 vector_type App;
 vector_type bb;
 sparse_matrix_type  mat_A;
 sparse_matrix_type  boundary_matrix;
int * boundary_marker;
 double  dot;
 double  rTr;
 double  rTr_old;
 double  orth;
 double lambda;
 int jmx_glob;
 renumber_type loc2glob;
int number;
int number_remain;
patch_type * patches;
patch_type my_patch;
int patches_length;
int no;
int nn;
int root;
double * to_buffer_values;
double * from_buffer_values;
double epsilon=0.0000001;

exch_set_type exch_data;
int number_of_potential_neighbours;
int ll;
int * loc2glob_length_to_array;
int * loc2glob_offset_to_array;
int * loc2glob_length_from_array;
int * global_neigh_indices;
int isum;
int length_global_neigh_indices;
  int * the_others_buffer_index;
  int * to_buffer_index;
  int * from_buffer_index;
  int * to_buffer_length_array;
  int * from_buffer_length_array;
  int * loc2glob_offset_from_array;
  int to_offset,from_offset;
  int * from_buffer_offset_array;
  int length_from_buffer_index;
int inner_length;
sparse_values_type boundary_values;
int * my_boundary_global_index_array;
int * my_boundary_local_index_array;
int number_of_local_boundary_values;
vector_type boundary_vector;
FILE *input;
   double time_start,time_end;
   double CG_time_start,CG_time_end;
   char nix;





  initialize_MPI(&argc, &argv);


  for( ii=0; ii<argc; ii++) {
	     printf("PE%i:\t %d %s\n",my_rank,ii,argv[ii]);
	       }

 
itermax=400;


number=comm_size;


	root=0;

if (my_rank == 0 ) {
        input=fopen("input.dat","r");
        fscanf(input,"%d%*",&jmin,nix);
        fscanf(input,"%d%*",&kmin,nix);
        fscanf(input,"%d%*",&jmax,nix);
        fscanf(input,"%d%*",&kmax,nix);
	printf("PE%i:\t main: jmin=%d,kmin=%d,jmax=%d,kmax=%d \n",my_rank,jmin,kmin,jmax,kmax);

	patches=malloc(number*sizeof(patch_type[1]));
// jmin, kmin, jmax, kmax describe the inner of the domain.
// Dirichlet boundaries are on jmin-1, kmin-1, jmax+1, kmax+1
	calculate_work_distribution( number,  jmin, kmin, jmax, kmax, patches, &patches_length);
	printf("PE%i:\t ended with calculate_work_distribution \n",my_rank);
}

communicate_patches(patches,&my_patch, root);

	printf("PE%i:\t main:vor jmin=%d,kmin=%d,jmax=%d,kmax=%d \n",my_rank,jmin,kmin,jmax,kmax);
	jmin=my_patch.global_bounds[0];
	kmin=my_patch.global_bounds[1];
	jmax=my_patch.global_bounds[2];
	kmax=my_patch.global_bounds[3];
	printf("PE%i:\t main:nach jmin=%d,kmin=%d,jmax=%d,kmax=%d \n",my_rank,jmin,kmin,jmax,kmax);

/* This constant is the offset for the next line */
jmx_glob=jmax+2;   // 2 for the boundaries

print_patch(my_patch);
	printf("PE%i:\t main: after printing data \n",my_rank);


/* if math_bound[]==1 we have a true mathematical boundary, not a domain boundary */
/*             _2_ (jmax,kmax)     */
/*            |   |                */
/*          3 |   | 1              */
/*            |   |                */
/* (jmin,kmin) ---                 */
/*              0                  */


   loc_jmin=my_patch.patch_bounds[0];
   loc_kmin=my_patch.patch_bounds[1];
   loc_jmax=my_patch.patch_bounds[2];
   loc_kmax=my_patch.patch_bounds[3];

length=(loc_jmax-loc_jmin+1)*(loc_kmax-loc_kmin+1);
number_of_rows=length;
number_of_entries=9*number_of_rows;


alloc_sparse_values_type(&boundary_values, (jmax+3-jmin)*(kmax+3-kmin), (jmax+3-jmin)*(kmax+3-kmin)) ;
set_sparse_values( &(boundary_values), jmin-1, kmin-1, jmax+1, kmax+1, jmx_glob);

	printf("PE%i:\t main: after set_sparse_values %d %d \n",my_rank,boundary_values.inner_length,boundary_values.length);
//     write_sparse_values_type("Dirichlet boundary condition values", boundary_values);


  alloc_sparse_matrix(&mat_A, number_of_rows, number_of_entries);
	printf("PE%i:\t main: after alloc_sparse_matrix \n",my_rank);



set_simple_row_ordered_mat_val(&mat_A,my_patch,jmx_glob);
	printf("PE%i:\t main: after set_simple_row_ordered_mat_val \n",my_rank);

write_sparse_matrix("matrix A",mat_A);

// the mat_A is defined by global numbers for the equations (elements) and the indices involved in the representation.
// renumber_sparse_matrix will change the representation to processor local numbers.
// the references between global and local numbers will be memorized in the struct loc2glob.

renumber_sparse_matrix(mat_A, &loc2glob) ;
//print_renumber_type("loc2glob after renumber_sparse_matrix" , loc2glob);

//write_sparse_matrix("after renumber_sparse_matrix matrix A",mat_A);



// we have to determine the local representives of the boundary_values
      my_boundary_global_index_array=malloc(boundary_values.length*sizeof(int));

// boundary_values.length is to large for allocation !
      my_boundary_local_index_array=malloc(boundary_values.length*sizeof(int));

find_subset_of_indices(
                                   boundary_values.index,boundary_values.length
                                  ,loc2glob.renumber,loc2glob.total_length
				  ,my_boundary_global_index_array    // indices in boundary_values.index[]
				  ,my_boundary_local_index_array     // indices in loc2glob.renumber[]
				  ,&(number_of_local_boundary_values)
                                  ) ;


length=loc2glob.total_length;
inner_length=loc2glob.inner_length;

alloc_vector_type(&boundary_vector,length,inner_length);

for(ll=0; ll< number_of_local_boundary_values; ll++){
   boundary_vector.values[my_boundary_local_index_array[ll]]=boundary_values.values[my_boundary_global_index_array[ll]];
}

//      write_vector_type("local boundary_vector= ",boundary_vector);

// here we extract the indices from the matrix which are related to the boundaries

// boundary_marker[] marks all local boundary indices by 1!
      boundary_marker=malloc(length*sizeof(int));

for(ll=0; ll< length ; ll++){
  boundary_marker[ll]=0.;
}
for(ll=0; ll< number_of_local_boundary_values ; ll++){
  boundary_marker[my_boundary_local_index_array[ll]]=1.;
}
//  print_array("boundary_marker:",boundary_marker,length);

// decompose_matrix will extract the boundary related indices from the matrix
// influence of the boundary values may be calculated by mat_A X boundary_vector
// but the boundary indices of mat_A have to be cut of
   decompose_matrix( mat_A,&(boundary_matrix),boundary_marker);

//write_sparse_matrix("local boundary_matrix ",boundary_matrix);
//write_sparse_matrix("matrix A with extracted boundaries ",mat_A);

      free(boundary_marker);

// the vector bb will be prepared as the right hand side of the equation
   alloc_vector_type(&bb,length,inner_length);
    matrix_vector( bb, boundary_matrix, boundary_vector );

//write_vector_type("bb= ",bb);

number_of_potential_neighbours=*(my_patch.number_proc_neighbours);

	printf("PE%i:\t main: temporary number_of_neighbours %d\n",my_rank,number_of_potential_neighbours);
allocate_exch_set(&exch_data,  number_of_potential_neighbours);

      loc2glob_length_to_array=malloc(number_of_potential_neighbours*sizeof(int));
      loc2glob_offset_to_array=malloc(number_of_potential_neighbours*sizeof(int));
    loc2glob_length_from_array=malloc(number_of_potential_neighbours*sizeof(int));
    loc2glob_offset_from_array=malloc(number_of_potential_neighbours*sizeof(int));

// preparation of the exchange of fixed sized data
for( ll=0; ll < number_of_potential_neighbours; ll++) {
   loc2glob_length_to_array[ll]=loc2glob.total_length - loc2glob.inner_length;
   loc2glob_offset_to_array[ll]=loc2glob.inner_length;
	}


// describe the potential processor numbers of the neighbourhood  in the local exch_set
define_neighbour_processors_exch_set(&exch_data, my_patch.neighbours );

print_array("processor numbers: ",exch_data.proc,number_of_potential_neighbours);


// transfer of the length information of loc2glob.renumber[] to be send in global_neigh_indices[] 
variables_exch_set(&exch_data, MPI_INT, loc2glob_length_to_array, loc2glob_length_from_array);

//print_array(" loc2glob_length_from_array after exchange ",loc2glob_length_from_array,number_of_potential_neighbours);


length_global_neigh_indices=calculate_offsets_from_length_array(
                                     loc2glob_length_from_array
                                    ,loc2glob_offset_from_array
                                    ,number_of_potential_neighbours);
printf("PE%i:\t length_global_neigh_indices = %d\n",my_rank, length_global_neigh_indices);

  global_neigh_indices   =malloc(length_global_neigh_indices*sizeof(int));
  to_buffer_index        =malloc(length_global_neigh_indices*sizeof(int));


// transfer of loc2glob.renumber[] to be send in global_neigh_indices[] 
        arrays_exch_set( &exch_data, MPI_INT
                        , loc2glob.renumber, loc2glob_offset_to_array, loc2glob_length_to_array
                        , global_neigh_indices, loc2glob_offset_from_array, loc2glob_length_from_array
                        );

//print_segmented(" global_neigh_indices after exchange ",global_neigh_indices,length_global_neigh_indices
//                                                       ,loc2glob_length_from_array,number_of_potential_neighbours);

    to_buffer_length_array=malloc(number_of_potential_neighbours*sizeof(int));
  from_buffer_offset_array=malloc(number_of_potential_neighbours*sizeof(int));

// global_neigh_indices[] are all indices of all global neighbours which are potential overlapping indices.
// The values in global_neigh_indices[] in the inner part of the local domain loc2glob.renumber[0:loc2glob.inner_length-1] 
// are determined.
// 
// the_others_buffer_index[] will be calculated in find_subset_of_indices.
// the_others_buffer_index[] points to the positions in the array global_neigh_indices.
// to_buffer_index[] is aligned with the_others_buffer_index[] and points to the local numbers 
// in definition range of loc2glob.renumber[].
// The definition range of to_buffer_index[from_offset + jj ] and 
// the definition range of the_others_buffer_index[from_offset + jj] are aligned.
// Both point to respective indices.
// the_others_buffer_index[from_offset + ...] has to be sent back to the neighbour.

  the_others_buffer_index=malloc(length_global_neigh_indices*sizeof(int));

for( ll=0; ll < number_of_potential_neighbours; ll++) {
              from_offset=loc2glob_offset_from_array[ll];
find_subset_of_indices(
                                   &(global_neigh_indices[from_offset]),loc2glob_length_from_array[ll]
                                  ,loc2glob.renumber,loc2glob.inner_length
				  ,&(the_others_buffer_index[from_offset])
				  ,&(to_buffer_index[from_offset])
				  ,&(to_buffer_length_array[ll])
                                  ) ;
	}

//print_segmented(" the_others_buffer_index after exchange ",the_others_buffer_index,length_global_neigh_indices
//                                                          ,loc2glob_length_from_array,number_of_potential_neighbours);

  from_buffer_length_array=malloc(number_of_potential_neighbours*sizeof(int));
variables_exch_set(&exch_data, MPI_INT 
                         , to_buffer_length_array
                         , from_buffer_length_array
                         );

length_from_buffer_index=calculate_offsets_from_length_array(
                                 from_buffer_length_array
                                ,from_buffer_offset_array
                                ,number_of_potential_neighbours);

//printf("PE%i:\t length_from_buffer_index = %d\n",my_rank, length_from_buffer_index);
//print_array(" from_buffer_length_array after exchange ",from_buffer_length_array,number_of_potential_neighbours);
//print_array(" from_buffer_offset_array after exchange ",from_buffer_offset_array,number_of_potential_neighbours);

// hide the not really involved processors 
hide_neighbour_processors_exch_set(&exch_data, from_buffer_length_array );

  from_buffer_index      =malloc(length_from_buffer_index*sizeof(int));

    arrays_exch_set( &exch_data, MPI_INT
                        , the_others_buffer_index,   loc2glob_offset_from_array,   to_buffer_length_array
                        ,       from_buffer_index, from_buffer_offset_array, from_buffer_length_array
                        );

  free(the_others_buffer_index);

// The information in from_buffer_index[] has to be understood as addressing after the inner part of loc2glob.renumber.
// We have to add up the offset loc2glob.inner_length.
for( nn=0; nn < length_from_buffer_index; nn++) {
     from_buffer_index[nn]=from_buffer_index[nn]+loc2glob.inner_length;
	}
//print_segmented(" from_buffer_index after exchange ",from_buffer_index,length_from_buffer_index
//                                                    ,from_buffer_length_array,number_of_potential_neighbours);


// from_buffer_index[] now contains the indices from all elements to be exchanged.
// from_buffer_offset_array[] contains the offsets for the respective neighbours.
// from_buffer_length_array[] contains the length of the parts of the respective neighbours.
// from_buffer_index[from_buffer_offset_array[ no ] + jj ] is the jj-th index of the no-th neighbour. 
// It is the local representation of the value of to_buffer_index[loc2glob_offset_from_array[my_no] + jj ] in the neighbour no
// if my_no is the local processor number.

// data exchange determining the neighbourhood 
//     local_proc:	send extrinsic global numbers to all potential neighbour_proc
// neighbour_proc:	receives length of buffer 
// neighbour_proc:	allocates extrinsic_array for receiving the requested extrinsic global numbers
// neighbour_proc:	receives the buffer in extrinsic_array 
// neighbour_proc:	determines values of extrinsic_array which are the global representation of the local numbers;
// 			calculates an index_array pointing to these local numbers (from_buffer.index);
// 			calculates an index_array for the same indices pointing to the extrinsic_array with the same global value.
// neighbour_proc:	sends back an array indicating the positions in the extrinsic_array that are local numbers
//     local_proc:	receives length of buffer 
//     local_proc:	allocates index_array for receiving the the position_array
//     local_proc:	receives index_array;	
//			this index_array points to the indices in the local numbering which have 
//			to be sent to neighbour_proc in future (to_buffer.index)


   to_buffer_values        =malloc(length_global_neigh_indices*sizeof(double));
   from_buffer_values      =malloc(length_from_buffer_index*sizeof(double));

/*
 *
 * test of exchange mechanism: begin
 *
 *alloc_vector_type(&test_vector,length,inner_length);
 *for( ll=0; ll < inner_length; ll++){
 *   test_vector.values[ll]=loc2glob.renumber[ll];
 *   test_vector.values[ll]=1.;
 *}
 *for( ll=inner_length; ll < length; ll++){
 *   test_vector.values[ll]=-loc2glob.renumber[ll];
 *   test_vector.values[ll]=1.;
 *}
 *
 *write_vector_type("vor Austausch test_vector = ",test_vector);
 *
 *exch_vector(&exch_data, test_vector
 *                        ,to_buffer_values,   to_buffer_index,  loc2glob_offset_from_array,to_buffer_length_array
 *                        ,from_buffer_values, from_buffer_index, from_buffer_offset_array, from_buffer_length_array
 *                              );
 *write_vector_type("after exchange of test_vector = ",test_vector);
 *      dotproduct(&dot, test_vector, test_vector);
 *      printf("PE%i:\t test_vectorTtest_vector=%f sqrt(test_vectorTtest_vector)= %f\n",my_rank,dot,sqrt(dot));
 *dealloc_vector_type(&test_vector);
 *
 * test of exchange mechanism: end
 */


// CG procedure: begin

alloc_vector_type(&xx,length,inner_length);

alloc_vector_type(&pp,length,inner_length);

alloc_vector_type(&rr,length,inner_length);

alloc_vector_type(&rr_old,length,inner_length);

alloc_vector_type(&Axx,length,inner_length);

alloc_vector_type(&App,length,inner_length);

 vector_to_vector( xx, bb);
// only for testing set_vector(xx,jmax,kmax);
exch_vector(&exch_data, xx
                        ,to_buffer_values,   to_buffer_index,  loc2glob_offset_from_array,to_buffer_length_array
                        ,from_buffer_values, from_buffer_index, from_buffer_offset_array, from_buffer_length_array
                              );

// we assure that boundary values are copied to the boundary parts of xx
// they will be not changed and not really used during matrix multiplication and dot_product.
     for(ll=xx.inner_length; ll < xx.length;  ll++) {
        xx.values[ll]=boundary_vector.values[ll];
     }

//    write_vector_type("xx = ",xx);
 matrix_vector( Axx, mat_A, xx );
//write_vector_type("Axx = ",Axx);

 vector_axpy(rr,bb,Axx,-1.);
//write_vector_type("rr = ",rr);

 vector_to_vector( pp, rr);
//write_vector_type("pp = ",pp);

 dotproduct(&rTr,rr,rr);
printf("PE%i:\t rTr = %f",my_rank,rTr);

      if (my_rank == 0 ) {
          CG_time_start=MPI_Wtime();
        } 
// CG iteration: begin
for (ii=0; ii<itermax; ii++) {

   time_start=MPI_Wtime();

      rTr_old=rTr ;

      exch_vector(&exch_data, pp
                 ,to_buffer_values,   to_buffer_index,  loc2glob_offset_from_array,to_buffer_length_array
                 ,from_buffer_values, from_buffer_index, from_buffer_offset_array, from_buffer_length_array
                 );

      matrix_vector(App, mat_A, pp);

      dotproduct(&dot, App, pp);
      if (my_rank == 0 ) {
         printf("PE%i:\t pTAp= %d %f\n",my_rank,ii,dot);
         printf("PE%i:\t log(abs(pTAp))= %d %f\n",my_rank,ii,log(fabs(dot)));
       }

      if ( sqrt(dot) < epsilon ) {
          printf("PE%i:\t  ending iteration for ii= %d with sqrt(pTAp)=%f \n",my_rank,ii,sqrt(dot));
           break ;
        }

      lambda = rTr / dot;
//      printf("PE%i:\t lambda = %f \n",my_rank,lambda);

      vector_update(xx, pp, lambda ) ;
    //write_vector_type("xx = ",xx);

//       vector_to_vector( rr_old, rr);    // nur Test

      vector_update(rr, App, -lambda ) ;

//       dotproduct(&orth,rr,rr_old);    // nur Test
//       if (my_rank == 0 ) {
//          printf("PE%i:\t orth = %f\n",my_rank,orth);    // nur Test
//        }

      dotproduct(&rTr,rr,rr);
      if (my_rank == 0 ) {
         printf("PE%i:\t rTr = %f\n",my_rank,rTr);
       }
      vector_update_r(pp, rr, rTr/rTr_old ) ;

   time_end=MPI_Wtime();
   printf("PE%i:\t CG iteration: time %f muesec \n",my_rank, (time_end-time_start)*1.e6);
   }
// CG iteration: end
      if (my_rank == 0 ) {
          CG_time_end=MPI_Wtime();
          printf("PE%i:\t total CG iteration: time %f muesec \n",my_rank, (CG_time_end-CG_time_start)*1.e6);
         }

// CG procedure: end

      exch_vector(&exch_data, xx
                        ,to_buffer_values,   to_buffer_index,  loc2glob_offset_from_array,to_buffer_length_array
                        ,from_buffer_values, from_buffer_index, from_buffer_offset_array, from_buffer_length_array
                              );
      matrix_vector( Axx, mat_A, xx );
      vector_axpy(rr,bb,Axx,-1.);
      dotproduct(&dot, rr, rr);
      if (my_rank == 0 ) {
         printf("PE%i:\t iteration finished: residual norm after iteration= %f\n",my_rank,sqrt(fabs(dot)));
       }
//      write_vector_type("residual vector = ",rr);
//      write_vector_type("result vector = ",xx);

//{
//   double xp,yp;
//   int jj,kk;
//    // printf("PE%i:\t jmin=%d ,kmin=%d ,jmax=%d ,kmax=%d jmx_glob=%d \n",my_rank,jmin,kmin,jmax,kmax,jmx_glob);
//     for(ll=0; ll < xx.length;  ll++) {
//        kk=loc2glob.renumber[ll]/jmx_glob;
//        jj=loc2glob.renumber[ll] - jmx_glob*kk;
//        jj=loc2glob.renumber[ll]%jmx_glob;
//        xp=((double)(jj-(jmin-1)))/((double)((jmax+1)-(jmin-1))) ;
//        yp=((double)(kk-(kmin-1)))/((double)((kmax+1)-(kmin-1))) ;
//        printf("PE%i:\t global_index xx %d %f \n",my_rank,loc2glob.renumber[ll],xx.values[ll]);
//        printf("PE%i:\t global_index bb %d %f \n",my_rank,loc2glob.renumber[ll],bb.values[ll]);
//        printf("PE%i:\t xp yp xx %f %f %f \n",my_rank,xp,yp,xx.values[ll]);
//     }
//}
dealloc_vector_type(&pp);
dealloc_vector_type(&rr);
dealloc_vector_type(&xx);
dealloc_vector_type(&Axx);
dealloc_vector_type(&App);
dealloc_vector_type(&bb);


dealloc_sparse_matrix(&mat_A);
dealloc_sparse_matrix(&boundary_matrix);

  finish_MPI();

    return(0);

//  finish_MPI();
//  exit(27);
}
/***************************************************************************************************************/
