#include "array.h"
#include <stdlib.h>
#include <limits.h>
#include <string.h>
#include "index_sort.h"

#define INFINITY INT_MAX




/**************************************************************************************/
int identify_global_indices_in_local_elements(
                                  int * mat_elements,int * renumber_elements ,int number_of_elements
                                 ,int * mat_index   ,int * renumber_index ,int number_of_index
                                 ,int * index_reference, int * element_reference ,int number_of_entries
                                  ){

  int ii,jj,nn;
  int outer_index_count;
  int index,old_index;
  int element;
  int total_length;
  int num;

	/*
	 * the routine serves for identification of identical values in array mat_elements[] and array mat_index[]
	 * mat_elements[renumber_elements[]]   must be sorted upwards and must be unique
	 * mat_index[renumber_index[]]   must be sorted upwards
	 * the values of mat_index[] are searched in the values of mat_elements[]
	 * index_reference[] describes the positions found in dependence on the origin indices of mat_index[]
	 * element_reference[] describes the positions found in dependence on the origin indices of mat_elements[]
         * in the follwing sense:
         * mat_index[index_reference[num]] == mat_elements[element_reference[num]] for num=0,...,total_length
	 * the return value is the total_length of all values found
         * total_length must not exceed number_of_entries. This is not tested.
	 */


		printf("PE%i:\t identify_global_indices_in_local_elements \n",my_rank);

  for( ii=0 ; ii < number_of_entries; ii++) {
		index_reference[ii]=-1;
		element_reference[ii]=-1;
	}

                num=0;
	/* handle index smaller than all elements */
		ii=0;
		index=mat_index[renumber_index[ii]];
		jj=0;
		element=mat_elements[renumber_elements[jj]];
//		printf("PE%i:\t element %5d %5d\n",my_rank 
//                                                ,renumber_elements[jj] 
//                                                ,mat_elements[renumber_elements[jj]]);
	  while( index < element && ii < number_of_index-1) {
		mat_index[renumber_index[ii]]=-(index+1);
		ii=ii+1;
		index=mat_index[renumber_index[ii]];
	  }
	  if( index == element) {
		index_reference[num]=renumber_index[ii];   /* kann auch anders sein */
		element_reference[num]=renumber_elements[jj];   /* kann auch anders sein */
//		printf("PE%i:\t v found %5d %5d %5d %5d %5d\n",my_rank
//                                                            ,num
//                                                            ,element_reference[num]
//                                                            ,index_reference[num]
//                                                            ,mat_elements[renumber_elements[jj]]
//                                                            ,mat_index[renumber_index[ii]]);
		num=num+1;
		ii=ii+1;
		}
	/* handling the remaining index value */
	  if( index < element ) {
		mat_index[renumber_index[ii]]=-(index+1);
		ii=ii+1;
		}

  for( ; ii < number_of_index; ii++) {
	  index=mat_index[renumber_index[ii]];
	  while( index > element && jj < number_of_elements-1) {
		jj=jj+1;
		element=mat_elements[renumber_elements[jj]];
//		printf("PE%i:\t element %5d %5d\n",my_rank
//                                                ,renumber_elements[jj]
//                                                ,mat_elements[renumber_elements[jj]]);
	  }
	  /* if index is part of the elements we have found this element 
	   * if index > element, index is not part of the elements
	   */
	  if( index == element) {
		index_reference[num]=renumber_index[ii];   /* kann auch anders sein */
		element_reference[num]=renumber_elements[jj];   /* kann auch anders sein */
//              printf("PE%i:\t h found %5d %5d %5d %5d %5d\n",my_rank
//                                                            ,num,element_reference[num]
//                                                            ,index_reference[num]
//                                                            ,mat_elements[renumber_elements[jj]]
//                                                            ,mat_index[renumber_index[ii]]);
		num=num+1;
		}
	  if( index != element) {
		/* we mark the index not part of the elements */
		mat_index[renumber_index[ii]]=-(index+1);
//		printf("PE%i:\t changed index %5d %5d\n",my_rank,renumber_index[ii],mat_index[renumber_index[ii]]);
	  }
   }

	total_length=num;
	return(total_length);
}
/**************************************************************************************/
int identify_global_indices_in_global_elements(
                                  int * mat_elements,int * renumber_elements ,int number_of_elements
                                 ,int * mat_index   ,int * renumber_index ,int number_of_index
                                 ,int * index_reference ,int number_of_entries
                                  ){

  int ii,jj,nn;
  int outer_index_count;
  int index,old_index;
  int element;
  int total_length;

	/*
	 * the routine serves for identification of identical values in array mat_elements[] and array mat_index[]
	 * mat_elements[renumber_elements[]]   must be sorted upwards and must be unique
	 * mat_index[renumber_index[]]   must be sorted upwards
	 * the values of mat_index are searched in the values of mat_elements
	 * index_reference[] describes the values found in dependence on the origin indices of mat_index[]
	 * for the values not found index_reference[] points to additional numbers over the offset number_of_elements
	 * index_reference points to the origin indices of renumber_elements[]
	 * the return value is the total_length off all values needed to represented all different values
	 */

		outer_index_count=0;

  for( ii=0 ; ii < number_of_entries; ii++) {
		index_reference[ii]=-4711;
	}

	/* handle index smaller than all elements */
		ii=0;
		index=mat_index[renumber_index[ii]];
		jj=0;
		element=mat_elements[renumber_elements[jj]];
//              printf("PE%i:\t element %5d %5d\n",my_rank
//                                                ,renumber_elements[jj]
//                                                ,mat_elements[renumber_elements[jj]]);
	  while( index < element && ii < number_of_index-1) {
		mat_index[renumber_index[ii]]=-(index+1);
		outer_index_count++;
		ii=ii+1;
		index=mat_index[renumber_index[ii]];
	  }
	  if( index == element) {
		index_reference[renumber_index[ii]]=jj;   /* kann auch anders sein */
		printf("PE%i:\t found %5d %5d\n",my_rank
                                                ,mat_elements[renumber_elements[jj]]
                                                ,mat_index[renumber_index[ii]]);
		ii=ii+1;
		}
	/* handling the remaining index value */
	  if( index < element ) {
		mat_index[renumber_index[ii]]=-(index+1);
		ii=ii+1;
		outer_index_count++;
		}

  for( ; ii < number_of_index; ii++) {
	  index=mat_index[renumber_index[ii]];
	  while( index > element && jj < number_of_elements-1) {
		jj=jj+1;
		element=mat_elements[renumber_elements[jj]];
//              printf("PE%i:\t element %5d %5d\n",my_rank
//                                                ,renumber_elements[jj]
//                                                ,mat_elements[renumber_elements[jj]]);
	  }
	  /* if index is part of the elements we have found this element 
	   * if index > element, index is not part of the elements
	   */
	  if( index == element) {
//              printf("PE%i:\t found %5d %5d\n",my_rank
//                                              ,mat_elements[renumber_elements[jj]]
//                                              ,mat_index[renumber_index[ii]]);
		index_reference[renumber_index[ii]]=jj;   /* kann auch anders sein */
		}
	  if( index != element) {
		/* we mark the index not part of the elements */
		mat_index[renumber_index[ii]]=-(index+1);
		outer_index_count++;
//              printf("PE%i:\t changed index %5d %5d\n",my_rank
//                                                      ,renumber_index[ii]
//                                                      ,mat_index[renumber_index[ii]]);
	  }
   }
                nn=number_of_elements-1; /* kann auch anders sein */
		old_index=+1; /* is diffent of all negative indices */
  for( ii=0 ; ii < number_of_index; ii++) {
	  index=mat_index[renumber_index[ii]];
	  if( index < 0) {
                if( old_index != index ) nn=nn+1;
		mat_index[renumber_index[ii]]=-(index+1);
		index_reference[renumber_index[ii]]=nn;   
//              printf("PE%i:\t changing back index %5d %5d %5d %5d\n",my_rank
//                                                                    ,renumber_index[ii]
//                                                                    ,mat_index[renumber_index[ii]]
//                                                                    ,nn
//                                                                    ,index_reference[renumber_index[ii]]);
			old_index=index;
		}
	}

	total_length=nn+1;
	return(total_length);
}
/**************************************************************************************/
void find_subset_of_indices(
                                   int * mat_index,int mat_number_of_entries
                                  ,int * mat_elements,int mat_number_of_rows
				  ,int * index_reference
				  ,int * element_reference
				  ,int * length_reference
                                  ) {
  int ii,jj;
  int length_local_to_global;
  int index;
  int element;
  int * renumber_elements;
  int * packed_renumber_elements;
  int   length_of_packed_renumber_elements;
  int * renumber_index;
  int * packed_renumber_index;
  int * inv_packed_renumber_index;
  int   length_of_packed_renumber_index;
  int * inv_packed_renumber_elements;

int length_of_packed_index_reference;
int * renum;
   double time_start;
   double time_end;

   time_start=MPI_Wtime();

  printf("PE%i:\t find_subset_of_indices: \n",my_rank);
  printf("PE%i:\t    mat_number_of_rows = %d \n",my_rank,mat_number_of_rows);
  printf("PE%i:\t mat_number_of_entries = %d \n",my_rank,mat_number_of_entries);

  renumber_elements =malloc(sizeof(int)*mat_number_of_rows);

// sorting of the mat_elements[]; not necessary if sorted
  sort_int_up(mat_elements,renumber_elements,mat_number_of_rows);

  //print_indirect( "find_subset_of_indices: renumbered elements", renumber_elements, mat_elements, mat_number_of_rows);


/* We assume that non unique mat_elements[] are allowed.
 * If mat_elements[] are unique the following step can be simplified.
 */
   inv_packed_renumber_elements   =malloc(sizeof(int)*mat_number_of_rows);  //OK

   packed_renumber_elements    =malloc(sizeof(int)*mat_number_of_rows);     //OK

// exclusion of multiple elements
   length_of_packed_renumber_elements=pack_renumbering_index(mat_elements,renumber_elements,mat_number_of_rows
                                                            ,packed_renumber_elements,inv_packed_renumber_elements); 

  //print_indirect( "find_subset_of_indices: packed renumbered elements", packed_renumber_elements, mat_elements, length_of_packed_renumber_elements);
  //print_aligned( "find_subset_of_indices: mapping of elements", mat_elements, inv_packed_renumber_elements, mat_number_of_rows);



  renumber_index    =malloc(sizeof(int)*mat_number_of_entries); //OK
// sorting of mat_index[] ; this seems to be necessary in any case
  sort_int_up(mat_index,renumber_index,mat_number_of_entries);

  //print_indirect( "find_subset_of_indices: renumbered indices", renumber_index, mat_index, mat_number_of_entries);


 printf("PE%i:\t find_subset_of_indices: vor identify_global_indices_in_local_elements\n",my_rank);
    *length_reference=identify_global_indices_in_local_elements(
                                                mat_elements,packed_renumber_elements,length_of_packed_renumber_elements
                                               ,mat_index   ,renumber_index,mat_number_of_entries
                                               ,index_reference,element_reference, mat_number_of_entries   
                                               );
 printf("PE%i:\t find_subset_of_indices: nach identify_global_indices_in_local_elements\n",my_rank);

/*
 * mat_elements[packed_renumber_elements[]] maps new elements to global elements
 * index_reference[] maps origin of the mat_indices to new values
 */

//print_aligned("find_subset_of_indices:    index_reference element_reference: "
//                    ,index_reference,element_reference,*length_reference);

  free(renumber_index);
  free(renumber_elements);
  free(packed_renumber_elements);
  free(inv_packed_renumber_elements);
   time_end=MPI_Wtime();
   printf("PE%i:\t find_subset_of_indices: time %f muesec \n",my_rank, (time_end-time_start)*1.e6);
/*
  fflush(NULL);
  exit_MPI(9);
  exit(9);
*/

}
/**************************************************************************************/
int pack_renumbering_index(int * mat_index,int * renumber_index,int mat_number_of_entries,int * packed_renumber_index, int * inv_packed_renumber_index) {
	int ii,jj;
	int value, value_old;
	int ren_index;
	int packed_size;
/* we assume that mat_index[renumber_index[]] is sorted 
 * and that renumber_index[] is a unique renumbering of the indices of array mat_index
 */
/* for the case that mat_index[renumber_index[]] is non unique
 * we generate packed_renumber_index[] so that mat_index[packed_renumber_index[]] is unique
 * and inv_packed_renumber_index[packed_renumber_index[jj]]=jj for all jj=0,...,packed_size-1
 * and packed_renumber_index[inv_packed_renumber_index[ii]]=ii for all ii=0,...,mat_number_of_entries-1
 */
	jj=-1;
	value_old=-INFINITY;
  for( ii=0 ; ii < mat_number_of_entries; ii++){
	ren_index=renumber_index[ii];
	value=mat_index[ren_index];
	if( value != value_old ){
		jj=jj+1;
		packed_renumber_index[jj]=ren_index;
	}
		inv_packed_renumber_index[ren_index]=jj;  /* constant on all parts with constant value */
	value_old=value;
	}
        packed_size=jj+1;
	return(packed_size);
}
/**************************************************************************************/
void print_indirect( char string[] , int * array1, int * array2, int length){
   int ii;
   printf("PE%i:\t \n",my_rank);
   printf("PE%i:\t %s\n",my_rank,string);
   printf("PE%i:\t ii arr1[ii] arr2[arr1[ii]]\n",my_rank);
  for( ii = 0 ; ii < length; ii++ ) {
   printf("PE%i:\t %5d %5d %5d \n",my_rank,ii,array1[ii],array2[array1[ii]]);
	}
   printf("PE%i:\t ii arr1[ii] arr2[arr1[ii]]\n",my_rank);
  }
/**************************************************************************************/
void print_aligned( char string[] , int * array1, int * array2, int length){
   int ii;
   printf("PE%i:\t \n",my_rank);
   printf("PE%i:\t %s\n",my_rank,string);
   printf("PE%i:\t ii arr1[ii] arr2[ii]\n",my_rank);
  for( ii = 0 ; ii < length; ii++ ) {
   printf("PE%i:\t %5d %5d %5d \n",my_rank,ii,array1[ii],array2[ii]);
	}
   printf("PE%i:\t ii arr1[ii] arr2[ii]\n",my_rank);
  }
/**************************************************************************************/
void print_segmented( char string[] , int * array1,int length1, int * array2, int length2){
   int ii1,ii2;
   int start,end;
   printf("PE%i:\t \n",my_rank);
   printf("PE%i:\t %s\n",my_rank,string);
   printf("PE%i:\t number of segments %d \n",my_rank,length2);
        start=0;
        end=0;
  for( ii2 = 0 ; ii2 < length2; ii2++ ) {
	end=end+array2[ii2];
              ii1=start;
 	  printf("PE%i:\t -> %5d %5d \n",my_rank,ii1,array1[ii1]);
 	 for( ii1 = start+1 ; ii1 < end; ii1++ ) {
 	  printf("PE%i:\t    %5d %5d \n",my_rank,ii1,array1[ii1]);
		}
        start=end;
	}
  }
/**************************************************************************************/
void print_array( char string[] , int * array, int length){
   int ii;
   printf("PE%i:\t \n",my_rank);
   printf("PE%i:\t %s\n",my_rank,string);
   printf("PE%i:\t ii arr[ii]\n",my_rank);
  for( ii = 0 ; ii < length; ii++ ) {
   printf("PE%i:\t %5d %5d \n",my_rank,ii,array[ii]);
	}
   printf("PE%i:\t ii arr[ii]\n",my_rank);
  }
/**************************************************************************************/
void print_renumber_type(char string[] , renumber_type renumber){
        int ii;
        printf("PE%i:\t \n",my_rank);
        printf("PE%i:\t %s\n",my_rank,string);
        printf("PE%i:\t inner indices %d  total indices %d \n",my_rank,renumber.inner_length,renumber.total_length);
        printf("PE%i:\t  inner indices: \n",my_rank);
for(ii=0; ii < renumber.inner_length; ii++ ){
        printf("PE%i:\t %d %d\n",my_rank,ii,renumber.renumber[ii]);
        }
        printf("PE%i:\t  outer indices: \n",my_rank);
for(ii=renumber.inner_length; ii < renumber.total_length; ii++ ){
        printf("PE%i:\t %d %d\n",my_rank,ii,renumber.renumber[ii]);
        }
        printf("PE%i:\t end of %s\n",my_rank,string);
        printf("PE%i:\t \n",my_rank);

}
/**************************************************************************************/
int calculate_offsets_from_length_array(int * length_array,int * offset_array,int length){
int sum;
int ll;
        sum=0;
for( ll=0; ll < length; ll++) {
	offset_array[ll]=sum;
	sum=sum+length_array[ll];
}
  return(sum);
}
/***************************************************************************************************************/
