#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <mpi.h>
#ifndef patch_DEF
   #define patch_DEF
   #include "patch.h"
#endif
#ifndef exchange_DEF
   #define exchange_DEF
   #include "exchange.h"
#endif




/***************************************************************************************************************/
void partitioning_2D_k(int* number_remain,int * jsize,int ksize,  int * blocks_k ){

	double djsize;
	double dksize;
	double dnumber;
	double work;
	double rel_work;
	double side_rel;
	double dblock_size_k;
	double dblock_size_j;
	double dj_remain;
	double block_size_k;
	int size_k;

djsize=*jsize;
dksize=ksize;
dnumber=*number_remain;

//printf("PE%i:\t djsize=%f\n",my_rank,djsize);
//printf("PE%i:\t dksize=%f\n",my_rank,dksize);

work=djsize*dksize;
//printf("PE%i:\t work=%f\n",my_rank,work);

rel_work=work/dnumber;
if(rel_work < 1. ) rel_work=1.;
//printf("PE%i:\t rel_work=%f\n",my_rank,rel_work);

dblock_size_k=sqrt(rel_work);
if( dblock_size_k < 1. ) dblock_size_k=1.;
//printf("PE%i:\t block_size_k=%f\n",my_rank,dblock_size_k);

//printf("PE%i:\t dksize/dblock_size_k=%f\n",my_rank,dksize/dblock_size_k);
*blocks_k=dksize/dblock_size_k;
if(*blocks_k < 1 ) *blocks_k=1;
if(*blocks_k > *number_remain ) *blocks_k=*number_remain;
//printf("PE%i:\t blocks_k=%d\n",my_rank,*blocks_k);

side_rel=dksize/djsize;
side_rel=1.;

dblock_size_j=djsize* *blocks_k/(*number_remain);
//printf("PE%i:\t block_size_j=%f\n",my_rank,dblock_size_j);

*jsize=djsize-dblock_size_j;
//printf("PE%i:\t jsize=%d\n",my_rank,*jsize);

*number_remain=*number_remain - *blocks_k;
/*
*/

}
/***************************************************************************************************************/
void calculate_work_distribution(int number,int  jmin,int kmin,int jmax,int kmax,patch_type * patches,int * patches_length){



int jsize,ksize;
int jsize_old;
int jsize_diff;
int j_remain;
int jmn,jmx;
int kk;
int no;
int k_diff;
int blocks_k;
int row_begin,row_end;
int row_begin_last,row_end_last;
int no_last;
int no_neigh;
int no_neigh_last;
int ll;
int number_remain;
double plot_diff;
double x_proc,y_proc;


for(no=0;no<number;no++){
	intialize_patch(&(patches[no]));
}

for(no=0;no<number;no++){
	patches[no].math_bounds[0]=0;
	patches[no].math_bounds[1]=0;
	patches[no].math_bounds[2]=0;
	patches[no].math_bounds[3]=0;
	patches[no].global_bounds[0]=jmin;
	patches[no].global_bounds[1]=kmin;
	patches[no].global_bounds[2]=jmax;
	patches[no].global_bounds[3]=kmax;
	*(patches[no].number_proc_neighbours)=0;
}

jsize_old=0;
jsize=jmax-jmin+1;ksize=kmax-kmin+1;
number_remain=number;
jmn=jmin;
jmx=0;
no=-1;
blocks_k=0;
	row_begin_last=-3;
	row_end_last=-10;
printf("PE%i:\t number %d jsize %d ksize %d blocks_k %d \n",my_rank,number,jsize,ksize, blocks_k);
while(jsize > 0 ) {
jsize_old=jsize;
partitioning_2D_k(&number_remain,&jsize,ksize, &blocks_k);
jsize_diff=-jsize+jsize_old;
jmx=jmx+jsize_diff;

   printf("PE%i:\t number_remain %d jsize %d ksize %d blocks_k %d \n",my_rank,number_remain,jsize,ksize, blocks_k);
   printf("PE%i:\t jsize_diff= %d\n",my_rank,jsize_diff);
   printf("PE%i:\t ksize/blocks_k %d\n",my_rank,ksize/blocks_k);
   printf("PE%i:\t ksize - blocks_k*(ksize/blocks_k) %d\n",my_rank,ksize - blocks_k*(ksize/blocks_k));

k_diff=ksize/blocks_k;
   printf("PE%i:\t blocks_k=%d\n",my_rank,blocks_k);
	patches[no+1].math_bounds[0]=1;
	row_begin=no+1;
for(kk=0;kk<blocks_k;kk++){
        no=no+1;
        no_neigh=0;
	patches[no].patch_bounds[0]=jmn; 
	patches[no].patch_bounds[1]=kmin+k_diff*kk; 
	patches[no].patch_bounds[2]=jmx;
	patches[no].patch_bounds[3]=kmin+k_diff*(kk+1)-1;

	if(jmn == jmin ) {patches[no].math_bounds[3]=1;}
	if(jmx == jmax ) {patches[no].math_bounds[1]=1;}

	if(kk > 0       ) { patches[no].neighbours[no_neigh]=no-1; no_neigh=no_neigh+1;}
	if(kk < blocks_k-1 ) { patches[no].neighbours[no_neigh]=no+1; no_neigh=no_neigh+1;}

	for(no_last=row_begin_last; no_last <= row_end_last; no_last++) {
	 if(patches[no_last].patch_bounds[1] <= patches[no].patch_bounds[3]+1 
	    &&
    	    patches[no_last].patch_bounds[3] >= patches[no].patch_bounds[1]-1 ) {
		patches[no].neighbours[no_neigh]=no_last; no_neigh=no_neigh+1;
		no_neigh_last=*(patches[no_last].number_proc_neighbours);
		patches[no_last].neighbours[no_neigh_last]=no; 
		*(patches[no_last].number_proc_neighbours)=no_neigh_last+1;
		}
}
	*(patches[no].number_proc_neighbours)=no_neigh;

}
	row_end=no;

	row_begin_last=row_begin;
	row_end_last=row_end;

	patches[no].patch_bounds[3]=kmax;
	patches[no].math_bounds[2]=1;
	jmn=jmx+1;

}

*patches_length=no+1;

if(*patches_length != number){
	printf("PE%i:\t error in calculate_work_distribution: \n");
	printf("PE%i:\t*patches_length=%d is not identical with number=%d \n",my_rank,*patches_length,number);
	printf("PE%i:\t may be that the number of processors is to large \n",my_rank);
	exit_MPI(17);
	exit(17);
}

for(no=0; no<*patches_length ; no++ ){
        plot_diff=0.+0.05*(patches[no].patch_bounds[3]-patches[no].patch_bounds[1]);

	printf("PE%i:\t patch_plot %d %d \n",my_rank,patches[no].patch_bounds[0],patches[no].patch_bounds[1]);
	printf("PE%i:\t patch_plot %d %d \n",my_rank,patches[no].patch_bounds[2],patches[no].patch_bounds[1]);
	printf("PE%i:\t patch_plot %d %d \n",my_rank,patches[no].patch_bounds[2],patches[no].patch_bounds[3]);
	printf("PE%i:\t patch_plot %d %d \n",my_rank,patches[no].patch_bounds[0],patches[no].patch_bounds[3]);
	printf("PE%i:\t patch_plot %d %d \n",my_rank,patches[no].patch_bounds[0],patches[no].patch_bounds[1]);
	printf("PE%i:\t patch_plot\n",my_rank);
	printf("PE%i:\t label_plot set label '(%d,%d)' at %f,%f left\n",my_rank
                           ,patches[no].patch_bounds[0],patches[no].patch_bounds[1]
	                   ,(double)patches[no].patch_bounds[0],(double)patches[no].patch_bounds[1]+plot_diff);
	printf("PE%i:\t label_plot set label '(%d,%d)' at %f,%f right\n",my_rank
                           ,patches[no].patch_bounds[2],patches[no].patch_bounds[1]
	                   ,(double)patches[no].patch_bounds[2],(double)patches[no].patch_bounds[1]+plot_diff);
	printf("PE%i:\t label_plot set label '(%d,%d)' at %f,%f right\n",my_rank
                           ,patches[no].patch_bounds[2],patches[no].patch_bounds[3]
	                   ,(double)patches[no].patch_bounds[2],(double)patches[no].patch_bounds[3]-plot_diff);
	printf("PE%i:\t label_plot set label '(%d,%d)' at %f,%f left\n",my_rank
                           ,patches[no].patch_bounds[0],patches[no].patch_bounds[3]
	                   ,(double)patches[no].patch_bounds[0],(double)patches[no].patch_bounds[3]-plot_diff);
         x_proc=0.5*(patches[no].patch_bounds[0]+patches[no].patch_bounds[2]);
         y_proc=0.5*(patches[no].patch_bounds[1]+patches[no].patch_bounds[3]);
	printf("PE%i:\t label_plot set label 'p_%d' at %f,%f left\n",my_rank,no,x_proc,y_proc);
//	printf("PE%i:\t %d %d %d %d \n",my_rank,patches[no].patch_bounds[0],patches[no].patch_bounds[1],patches[no].patch_bounds[2],patches[no].patch_bounds[3]);
}
/* boundary flags */
for(no=0; no<*patches_length ; no++ ){
	printf("PE%i:\t    %d %d %d %d %d \n",my_rank,no,patches[no].math_bounds[0],patches[no].math_bounds[1],patches[no].math_bounds[2],patches[no].math_bounds[3]);
}
/* neighbours */
	printf("PE%i:\t neighbourhood \n",my_rank);
for(no=0; no<*patches_length ; no++ ){
	printf("PE%i:\t neighbours  of %d \n",my_rank,no);
	for(no_neigh=0; no_neigh < *(patches[no].number_proc_neighbours) ; no_neigh++ ){
		printf("PE%i:\t %d ",my_rank,patches[no].neighbours[no_neigh]);
	}
	printf("PE%i:\t \n");
}
}
/***************************************************************************************************************/
void intialize_patch(patch_type * patch){
	patch->patch_bounds          =&(patch->data[PATCH_N1]);
	patch->global_bounds         =&(patch->data[PATCH_N2]);
	patch->math_bounds           =&(patch->data[PATCH_N3]);
	patch->number_proc_neighbours=&(patch->data[PATCH_N4]);
	patch->neighbours            =&(patch->data[PATCH_N5]);
	}
/***************************************************************************************************************/
void print_patch(patch_type patch){
int no_neigh;

	printf("PE%i:\t patch boundaries %d %d %d %d \n",my_rank,patch.patch_bounds[0],patch.patch_bounds[1],patch.patch_bounds[2],patch.patch_bounds[3]);
/* boundary flags */
	printf("PE%i:\t patch boundary flags %d %d %d %d  \n",my_rank,patch.math_bounds[0],patch.math_bounds[1],patch.math_bounds[2],patch.math_bounds[3]);

/* neighbours */
	printf("PE%i:\t neighbourhood %d \n",my_rank,*(patch.number_proc_neighbours));
	for(no_neigh=0; no_neigh < *(patch.number_proc_neighbours) ; no_neigh++ ){
		printf("PE%i:\t %d ",my_rank,patch.neighbours[no_neigh]);
	}
	printf("PE%i:\t \n");
}
/***************************************************************************************************************/
void communicate_patches(patch_type * patches,patch_type * my_patch, int root){
int no;
int nn;
int * recvbuf;
int * sendbuf;
int * sendcounts;
int * displs;
int recvcount;

	recvcount=PATCH_N0;
	recvbuf=(int *)malloc(PATCH_N0*sizeof(int));
if (my_rank == 0 ) {
	sendbuf=patches[0].data;
	displs=(int *)malloc(comm_size*sizeof(int));
	sendcounts=(int *)malloc(comm_size*sizeof(int));
for(no=0; no < comm_size; no++){
	displs[no]=patches[no].data - patches[0].data;
	sendcounts[no]=PATCH_N0;
	}
}
//	printf("PE%i:\t communicate_patches: before MPI_Scatterv \n",my_rank);
	MPI_Scatterv(sendbuf,sendcounts,displs,MPI_INT,recvbuf,recvcount,MPI_INT,root,comm_comm);
//	printf("PE%i:\t communicate_patches: after MPI_Scatterv \n",my_rank);

 intialize_patch(my_patch);

//	printf("PE%i:\t communicate_patches: after intialize_patch \n",my_rank);
for(nn=0; nn < recvcount; nn++){
	my_patch->data[nn]=recvbuf[nn];
//	printf("PE%i:\t communicate_patches: %d %d \n",my_rank,nn,my_patch->data[nn]);
}
//	printf("PE%i:\t communicate_patches: after copying data \n",my_rank);
    free(recvbuf);

}
/***************************************************************************************************************/
