#ifndef vector_DEF
   #define vector_DEF
   #include "vector.h"
#endif
#ifndef array_DEF
   #define array_DEF
   #include "array.h"
#endif
#ifndef patch_DEF
   #define patch_DEF
   #include "patch.h"
#endif
   typedef struct {
                    double * mat_aa ;
                    int matrix_type;
                    int * mat_index ;
                    int * mat_elements ;
                    int * mat_number_of_row_elements ;
                    int mat_number_of_rows ;
                    int mat_number_of_entries ;
                    double * xx ;
                    double * yy ;
                                  } sparse_matrix_type;

 void test_matrix_type(sparse_matrix_type matrix);
   void test_matrix_type_kernel(
                                   double * mat_aa
                                  ,int * mat_index
                                  ,int * mat_elements
                                  ,int * mat_number_of_row_elements
                                  ,int mat_number_of_rows
                                  ,int mat_number_of_entries
                                  ,int *matrix_type
                                  ,int * total_number_of_operations
                                  );
void matrix_vector( vector_type , sparse_matrix_type , vector_type  );
   void sparse_matrix_vector_kernel(
                                   double * yy
                                  ,double * mat_aa
                                  ,int * mat_index
                                  ,int * mat_elements
                                  ,int * mat_number_of_row_elements
                                  ,int mat_number_of_rows
                                  ,int mat_number_of_entries
                                  ,int *matrix_type
                                  ,double * xx
                                  ,int * total_number_of_operations
                                  );
void set_simple_row_ordered_mat_val_kernel_2(  
                                                  double * mat_aa  
                                                 ,int * mat_index  
                                                 ,int * mat_elements  
                                                 ,int * mat_number_of_row_elements  
                                                 ,int * mat_number_of_rows  
                                                 ,int * mat_number_of_entries  
                                                 ,int * matrix_type  
                                                 ,int * patch_bounds, int jmx_glob,int * math_bound);

void write_sparse_matrix(char [], sparse_matrix_type ) ;

void write_sparse_matrix_kernel( double * ,int * ,int * ,int * ,int ,int );

void alloc_sparse_matrix(sparse_matrix_type * , int , int );

void dealloc_sparse_matrix(sparse_matrix_type * );

void set_simple_row_ordered_mat_val(sparse_matrix_type * mat_A, patch_type  patch,int jmx_glob) ;
void set_simple_row_ordered_mat_val_kernel(  
                                                  double * mat_aa  
                                                 ,int * mat_index  
                                                 ,int * mat_elements  
                                                 ,int * mat_number_of_row_elements  
                                                 ,int * mat_number_of_rows  
                                                 ,int * mat_number_of_entries  
                                                 ,int * matrix_type  
                                                 ,int * patch_bounds, int jmx_glob,int * math_bound);

void renumber_sparse_matrix(sparse_matrix_type matrix, renumber_type *) ;
void renumber_sparse_matrix_kernel(
                                   int * mat_index
                                  ,int * mat_elements
                                  ,int mat_number_of_rows
                                  ,int mat_number_of_entries
				  ,renumber_type *
                                  );
   void decompose_matrix( sparse_matrix_type matrix,sparse_matrix_type * matrix_new,int * marker);
   void decompose_matrix_kernel_size(
                                   int * mat_index
                                  ,int * mat_elements
                                  ,int * mat_number_of_row_elements
                                  ,int mat_number_of_rows
                                  ,int mat_number_of_entries
                                  ,int * mat_number_of_rows_new
                                  ,int * mat_number_of_entries_new
                                  ,int * marker
                                  );
   void decompose_matrix_kernel_data(
                                   double * mat_aa
                                  ,int * mat_index
                                  ,int * mat_elements
                                  ,int * mat_number_of_row_elements
                                  ,int mat_number_of_rows
                                  ,int mat_number_of_entries
                                  ,double * mat_aa_new
                                  ,int * mat_index_new
                                  ,int * mat_elements_new
                                  ,int * mat_number_of_row_elements_new
                                  ,int * mat_number_of_rows_new
                                  ,int * mat_number_of_entries_new
                                  ,int * matrix_type
                                  ,int * marker
                                  );
